Name:          syslog4j
Version:       0.9.46
Release:       1%{?dist}
Summary:       Complete Syslog Implementation for Java
License:       LGPLv2+
URL:           http://www.syslog4j.org/
Source0:       http://www.syslog4j.org/downloads/%{name}-%{version}-src.jar
Source1:       http://www.syslog4j.org/downloads/%{name}-%{version}-junit.jar
# Custom pom file
Source2:       syslog4j-template.pom
# Add jna missing method
Patch0:        syslog4j-0.9.46-jna4.patch

BuildRequires: maven-local
BuildRequires: mvn(commons-pool:commons-pool)
BuildRequires: mvn(joda-time:joda-time)
BuildRequires: mvn(junit:junit)
BuildRequires: mvn(net.java.dev.jna:jna)
BuildRequires: mvn(log4j:log4j:1.2.17)

BuildArch:     noarch

%description
Syslog4j provides client and server implementations of the
BSD Syslog protocol (RFC 3164) and the Structured Syslog
protocol (RFC 5424).

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -T -q -c

mkdir -p src/main/{java,resources}

(
  cd src/main/java
  %jar -xf %{SOURCE0}
  rm META-INF/MANIFEST.MF
  mv META-INF ../resources
)

%patch0 -p1

# Convert from dos to unix line ending
for file in src/main/resources/META-INF/CHANGELOG.txt \
  src/main/resources/META-INF/RFC3164.txt
do
 sed -i.orig 's|\r||g' $file
 touch -r $file.orig $file
 rm $file.orig
done

cp -p src/main/resources/META-INF/*.txt .

# clone source directory structure
find src/main/java/ -type d | while read dirname ; do
  newdirname=`echo $dirname | sed "s:src/main/java:src/main/resources:g"`
  mkdir -p $newdirname
done

# copy everything except *.java sources
find src/main/java/ -type f | grep -v "\.java" | while read cpfrom ; do
  cpto=`echo $cpfrom | sed "s:src/main/java:src/main/resources:g"`
  cp $cpfrom $cpto
done

# Prepare test suite
mkdir -p src/test/{java,resources}

(
  cd src/test/java
  %jar -xf %{SOURCE1}
  rm -r META-INF
)

# Cleanup
find . -name "*.class" -delete

# clone source directory structure
find src/test/java/ -type d | while read dirname ; do
  newdirname=`echo $dirname | sed "s:src/test/java:src/test/resources:g"`
  mkdir -p $newdirname
done

# copy everything except *.java sources
find src/test/java/ -type f | grep -v "\.java" | while read cpfrom ; do
  cpto=`echo $cpfrom | sed "s:src/test/java:src/test/resources:g"`
  cp $cpfrom $cpto
done

cp -p %{SOURCE2} pom.xml
sed -i "s|@VERSION@|%{version}|" pom.xml

# AssertionFailedError:
# Problem: 1000 990
rm src/test/java/org/productivity/java/syslog4j/test/net/NonPersistentTCPNetSyslog4jTest.java
# expected:<4> but was:<0>
rm src/test/java/org/productivity/java/syslog4j/test/net/SyslogServerSessionTest.java
# expected:<For now is the [...]> but was:<For now is the [tim]>
rm -r src/test/java/org/productivity/java/syslog4j/test/split
# Protocol "udp" does not exist
rm src/test/java/org/productivity/java/syslog4j/test/net/UDPNetSyslog4jTest.java \
 src/test/java/org/productivity/java/syslog4j/test/message/modifier/SyslogMessageModifierTest.java \
 src/test/java/org/productivity/java/syslog4j/test/message/UDPPCISyslogMessageTest.java \
 src/test/java/org/productivity/java/syslog4j/test/message/modifier/SyslogMessageModifierVerifyTest.java
# No recorded events received
rm src/test/java/org/productivity/java/syslog4j/test/net/BackLogTCPNetSyslog4jTest.java
sed -i '/BackLogTCPNetSyslog4jTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
sed -i '/NonPersistentTCPNetSyslog4jTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
sed -i '/SplitSyslogTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
sed -i '/SyslogMessageModifierTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
sed -i '/SyslogMessageModifierVerifyTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
sed -i '/SyslogServerSessionTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
sed -i '/UDPNetSyslog4jTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
sed -i '/UDPPCISyslogMessageTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
# FileNotFoundException: certs/ssltest.jks
rm src/test/java/org/productivity/java/syslog4j/test/net/PooledSSLTCPNetSyslog4jTest.java \
 src/test/java/org/productivity/java/syslog4j/test/net/SSLTCPNetSyslog4jTest.java
sed -i '/PooledSSLTCPNetSyslog4jTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
sed -i '/SSLTCPNetSyslog4jTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
# NullPointerException
rm src/test/java/org/productivity/java/syslog4j/test/net/CommandLineNetSyslog4jTest.java
sed -i '/CommandLineNetSyslog4jTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
# SyslogRuntimeException
#  Syslog protocol "maxQueueSizeTest" already defined
rm src/test/java/org/productivity/java/syslog4j/test/net/MaxQueueSizeTest.java
#  Syslog protocol "fake1" already defined
rm src/test/java/org/productivity/java/syslog4j/test/multiple/MultipleSyslogCreateTest.java
#  Syslog protocol "tcp" not defined
rm src/test/java/org/productivity/java/syslog4j/test/net/TCPNetSyslog4jTest.java
#  Syslog protocol "unix_syslog" not defined
rm src/test/java/org/productivity/java/syslog4j/test/unix/UnixSyslogTest.java
# Syslog protocol "testStructuredSyslog" already defined
rm src/test/java/org/productivity/java/syslog4j/test/misc/SyslogParameterTest.java
sed -i '/MaxQueueSizeTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
sed -i '/MultipleSyslogCreateTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
sed -i '/TCPNetSyslog4jTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
sed -i '/UnixSyslogTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
sed -i '/SyslogParameterTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
# UnsupportedOperationException: Not supported
rm src/test/java/org/productivity/java/syslog4j/test/unix/socket/UnixSocketSyslogTest.java
sed -i '/UnixSocketSyslogTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
# UnknownHostException: buildvm-26.phx2.fedoraproject.org: buildvm-26.phx2.fedoraproject.org: unknown error
rm src/test/java/org/productivity/java/syslog4j/test/server/event/ServerEventTest.java
rm src/test/java/org/productivity/java/syslog4j/test/message/pci/PCISyslogMessageTest.java
sed -i '/event.ServerEventTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
sed -i '/ServerEventTest.class/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java
sed -i '/PCISyslogMessageTest/d' src/test/java/org/productivity/java/syslog4j/test/Syslog4jTest.java

%mvn_file :%{name} %{name}
%mvn_alias : org.productivity.java:

%build

# No test suite available
%mvn_build

%install
%mvn_install

%files -f .mfiles
%doc CHANGELOG.txt RFC3164.txt RFC3339.txt RFC5424.txt
%license LICENSE.txt

%files javadoc -f .mfiles-javadoc
%license LICENSE.txt

%changelog
* Thu Apr 14 2016 gil cattaneo <puntogil@libero.it> 0.9.46-1
- initial rpm

